Re: [PATCH v3 06/12] bisect--helper: finish porting `bisect_start()` to C
From: Johannes Schindelin <hidden>
Date: 2020-05-22 21:08:20
Hi Miriam, On Thu, 23 Apr 2020, Miriam Rubio wrote:
From: Pranit Bauva <redacted> Add the subcommand to `git bisect--helper` and call it from git-bisect.sh. With the conversion of `bisect_auto_next()` from shell to C in a previous commit, `bisect_start()` can now be fully ported to C. So let's complete the `--bisect-start` subcommand of `git bisect--helper` so that it fully implements `bisect_start()`, and let's use this subcommand in `git-bisect.sh` instead of `bisect_start()`. This removes the signal handling we had in `bisect_start()` as we don't really need it. While at it, "trap" is changed to "handle".
I do not see any "handle" in the diff...
As "trap" is a reference to the shell "trap" builtin, which isn't used anymore.
Otherwise, the commit message looks good to me!
quoted hunk ↗ jump to hunk
Mentored-by: Christian Couder [off-list ref] Mentored-by: Johannes Schindelin [off-list ref] Signed-off-by: Pranit Bauva <redacted> Signed-off-by: Tanushree Tumane <redacted> Signed-off-by: Miriam Rubio <redacted> --- builtin/bisect--helper.c | 54 +++++++++++++++++++++++++++++++--------- git-bisect.sh | 26 ++----------------- 2 files changed, 44 insertions(+), 36 deletions(-)diff --git a/builtin/bisect--helper.c b/builtin/bisect--helper.c index c6aaa8eb15..f2ec7f89e4 100644 --- a/builtin/bisect--helper.c +++ b/builtin/bisect--helper.c@@ -588,11 +588,12 @@ static enum bisect_error bisect_auto_next(struct bisect_terms *terms, const char return bisect_next(terms, prefix); } -static int bisect_start(struct bisect_terms *terms, int no_checkout, +static enum bisect_error bisect_start(struct bisect_terms *terms, int no_checkout, const char **argv, int argc) { int i, has_double_dash = 0, must_write_terms = 0, bad_seen = 0; - int flags, pathspec_pos, res = 0; + int flags, pathspec_pos; + enum bisect_error res = BISECT_OK; struct string_list revs = STRING_LIST_INIT_DUP; struct string_list states = STRING_LIST_INIT_DUP; struct strbuf start_head = STRBUF_INIT;@@ -645,9 +646,12 @@ static int bisect_start(struct bisect_terms *terms, int no_checkout, return error(_("unrecognized option: '%s'"), arg); } else { char *commit_id = xstrfmt("%s^{commit}", arg); - if (get_oid(commit_id, &oid) && has_double_dash) - die(_("'%s' does not appear to be a valid " - "revision"), arg); + if (get_oid(commit_id, &oid) && has_double_dash) { + error(_("'%s' does not appear to be a valid " + "revision"), arg); + free(commit_id); + return BISECT_FAILED; + }
Makes sense.
quoted hunk ↗ jump to hunk
string_list_append(&revs, oid_to_hex(&oid)); free(commit_id);@@ -725,12 +729,12 @@ static int bisect_start(struct bisect_terms *terms, int no_checkout, * Get rid of any old bisect state. */ if (bisect_clean_state()) - return -1; + return BISECT_FAILED; /* - * In case of mistaken revs or checkout error, or signals received, + * In case of mistaken revs or checkout error, * "bisect_auto_next" below may exit or misbehave. - * We have to trap this to be able to clean up using + * We have to handle this to be able to clean up using * "bisect_clean_state". */@@ -746,7 +750,7 @@ static int bisect_start(struct bisect_terms *terms, int no_checkout, } if (update_ref(NULL, "BISECT_HEAD", &oid, NULL, 0, UPDATE_REFS_MSG_ON_ERR)) { - res = -1; + res = BISECT_FAILED; goto finish; } }@@ -758,25 +762,51 @@ static int bisect_start(struct bisect_terms *terms, int no_checkout, for (i = 0; i < states.nr; i++) if (bisect_write(states.items[i].string, revs.items[i].string, terms, 1)) { - res = -1; + res = BISECT_FAILED; goto finish; } if (must_write_terms && write_terms(terms->term_bad, terms->term_good)) { - res = -1; + res = BISECT_FAILED; goto finish; } res = bisect_append_log_quoted(argv); if (res) - res = -1; + res = BISECT_FAILED; finish: string_list_clear(&revs, 0); string_list_clear(&states, 0); strbuf_release(&start_head); strbuf_release(&bisect_names); + if (res) + return res; + + res = bisect_auto_next(terms, NULL); + /* + * In case of mistaken revs or checkout error, or signals received, + * "bisect_auto_next" below may exit or misbehave.
This "below" was true in the shell script version, but now it should be "above".
quoted hunk ↗ jump to hunk
+ * We have to handle this to be able to clean up using + * "bisect_clean_state". + * return code BISECT_INTERNAL_SUCCESS_MERGE_BASE is special code + * that indicates special success.
Maybe we should have a helper function and use it here:
static int is_bisect_success(enum bisect_error res)
{
return !res ||
res == BISECT_INTERNAL_1ST_BAD_FOUND ||
res == BISECT_INTERNAL_SUCCESS_MERGE_BASE;
}
(Note that I added the `_1ST_BAD_FOUND` case here.)
quoted hunk ↗ jump to hunk
+ * -> bisect_start() + * . res = bisect_auto_next() + * -> bisect_auto_next() + * . return bisect_next() + * -> bisect_next() + * . res = bisect_next_all() + * -> bisect_next_all() + * . res = check_good_are_ancestors_of_bad() + * -> check_good_are_ancestors_of_bad() + * . res = check_merge_bases() + * -> check_merge_bases() + * . res = BISECT_INTERNAL_SUCCESS_MERGE_BASE
While this might be an interesting tidbit for the commit message, I do not think that it is a good idea to keep this as a code comment; It is prone to become stale/incorrect over time.
quoted hunk ↗ jump to hunk
+ */ + if (res && res != BISECT_INTERNAL_SUCCESS_MERGE_BASE) + bisect_clean_state(); return res; }diff --git a/git-bisect.sh b/git-bisect.sh index 897825b675..049ffacdff 100755 --- a/git-bisect.sh +++ b/git-bisect.sh@@ -49,27 +49,6 @@ bisect_head() fi } -bisect_start() { - git bisect--helper --bisect-start $@ || exit - - # - # Change state. - # In case of mistaken revs or checkout error, or signals received, - # "bisect_auto_next" below may exit or misbehave. - # We have to trap this to be able to clean up using - # "bisect_clean_state". - # - trap 'git bisect--helper --bisect-clean-state' 0 - trap 'exit 255' 1 2 3 15 - - # - # Check if we can proceed to the next bisect state. - # - git bisect--helper --bisect-auto-next || exit - - trap '-' 0 -} - bisect_skip() { all='' for arg in "$@"@@ -162,8 +141,7 @@ bisect_replay () { get_terms case "$command" in start) - cmd="bisect_start $rev" - eval "$cmd" ;; + eval "git bisect--helper --bisect-start $rev" ;;
The original code _had_ to use `eval` because `bisect_start` could cause the code to `exit` and we did _not_ want to let that exit the `replay` process. However, we are calling `git bisect--helper` here, which runs in its own process anyway, so the `eval` should be dropped now. Otherwise, the patch looks fine to me, Dscho
quoted hunk ↗ jump to hunk
"$TERM_GOOD"|"$TERM_BAD"|skip) git bisect--helper --bisect-write "$command" "$rev" "$TERM_GOOD" "$TERM_BAD" || exit;; terms)@@ -262,7 +240,7 @@ case "$#" in help) git bisect -h ;; start) - bisect_start "$@" ;; + git bisect--helper --bisect-start "$@" ;; bad|good|new|old|"$TERM_BAD"|"$TERM_GOOD") bisect_state "$cmd" "$@" ;; skip) --2.25.0